local Een = CreateFrame("FRAME"); -- Need a frame to respond to events
Een:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
Een:RegisterEvent("PLAYER_LOGIN"); -- Fired when logging in
Een:RegisterEvent("UPDATE_CHAT_WINDOWS"); -- Fired when updating the chat windows

function Een_Save_Chat()
	Een_ChatFrame = { };
	
	for i=1,NUM_CHAT_WINDOWS do
		local f = _G["ChatFrame"..i];
		local point, relativeTo, relativePoint, xOfs, yOfs = f:GetPoint();
		local name, fontSize, r, g, b, alpha, shown, locked, docked, uninteractable = GetChatWindowInfo(i);
		local DefaultChannels = { GetChatWindowMessages(f:GetID())};
		Een_ChatFrame[i] = {f:GetWidth(), f:GetHeight(), point, relativePoint, xOfs, yOfs, name, fontSize, r, g, b, alpha, shown, locked, docked, uninteractable, DefaultChannels};
	end
end

function Een_Assimilate_Chat(args)
	for i=1,NUM_CHAT_WINDOWS do
		local f = _G["ChatFrame"..i];
		local tmp_ChatFrame = Een_ChatFrame[i];
		local tmp_OldChatMsgType = { GetChatWindowMessages(f:GetID())};
		if tmp_ChatFrame[15] == 1 or tmp_ChatFrame[15] == nil then 
			for k=1,#tmp_OldChatMsgType do
				RemoveChatWindowMessages(i, tmp_OldChatMsgType[k]);
			end
			local tmp_ChatMsgType = tmp_ChatFrame[17];
			for j=1,#tmp_ChatFrame[17] do
				AddChatWindowMessages(i, tmp_ChatMsgType[j]);
			end
			SetChatWindowName(i,tmp_ChatFrame[7]);
			SetChatWindowSize(i,tmp_ChatFrame[8]);
			SetChatWindowColor(i,tmp_ChatFrame[9],tmp_ChatFrame[10],tmp_ChatFrame[11]);
			SetChatWindowAlpha(i,tmp_ChatFrame[12]);
			SetChatWindowShown(i,tmp_ChatFrame[13]);
			SetChatWindowLocked(i,tmp_ChatFrame[14]);
			SetChatWindowDocked(i,tmp_ChatFrame[15]);
			SetChatWindowUninteractable(i,tmp_ChatFrame[16]);
			f:ClearAllPoints();
			f:SetWidth(tmp_ChatFrame[1]);
			f:SetHeight(tmp_ChatFrame[2]);
			f:SetPoint(tmp_ChatFrame[3], UIParent, tmp_ChatFrame[4], tmp_ChatFrame[5], tmp_ChatFrame[6]);
			f:SetUserPlaced(true);
		end
	end
	if args ~= 'load' then message("Chat windows have been set, please enter /console reloadui.") end;
end

function Een:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "Een" then
		print("Een's addon loaded.");
	elseif event == "PLAYER_LOGIN" or event == "UPDATE_CHAT_WINDOWS" then
		Een_Assimilate_Chat("load");
	end
end

Een:SetScript("OnEvent", Een.OnEvent);

SLASH_EEN1 = "/een";
SlashCmdList["EEN"] = function(msg)
	if msg == 'save' then
		Een_Save_Chat();
	elseif msg == 'load' then
		Een_Assimilate_Chat();
	else
		print("Welcome to Een's Chat Window backup");
		print("Usage:");
		print("/een save - Save the current character's chat windows");
		print("/een load - Load the backup");
	end
end